// standard boilerplate start for .h file -- avoids duplication if the file
// is #include'd more than once
// FIXME change this if you copy this file
#ifndef PAGE_REFERENCE_H
#define PAGE_REFERENCE_H

#include <cstdio>
#include <cstdlib>
#include <string>

using std::string;

class PageReference {
    public:

        // variables

        const long time;
        const long pageNumber;
        const bool isWrite;

        // constructor

        PageReference(const long time_,
                const long num_, 
                const bool write_) 
            : time(time_), pageNumber(num_), isWrite(write_) 
        {}

        // methods

        string toString(void) {
            return 
                std::to_string(time) + " " +
                (isWrite ? "W" : "R") + " " + 
                std::to_string(pageNumber);
        }
};
#endif
