#include <cstdlib>
#include <cassert>

#include "pra-Base.hpp"

#include "page-reference.hpp"
#include "results.hpp"

#include "pte.hpp"

#include <string>
#include <vector>

using std::string;
using std::vector;

class PRA_SecondChance : public PRA {

    private:

        // variables to be used in simulation 
        // (make them member variables so all methods have access)

        // HINT:  okay to remove this but I think it's useful
        Results results; 

        // FIXME add variables here?

    public:

        // methods required by superclass

        // provide name of algorithm
        string getName(void) const;

        // simulate operation of algorithm 
        Results simulate(
                const long numFrames,
                const long numPages,
                const long interval, 
                const long tau,
                const vector<PageReference> &refs);
    private:

        // methods for this class
        
        // FIXME add method declarations here?

};

// methods required by superclass

string PRA_SecondChance::getName(void) const { return "Second Chance"; }

Results PRA_SecondChance::simulate(
        const long numFrames,
        const long numPages,
        const long interval,
        const long tau,
        const vector<PageReference> &refs)
{
    if (DEBUG) {
        printf("simulating %s\n", getName().c_str());
    }
    results.clear();

    // FIXME add code here

    if (DEBUG) { puts(""); }
    // FIXME change to "true" if you implement this algorithm.
    results.isValid = false; 
    return results;
}

// methods for this class

// FIXME add definitions of other methods

